/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package fixtures.azurespecials;

import com.microsoft.rest.AzureClient;
import com.microsoft.rest.credentials.ServiceClientCredentials;
import com.squareup.okhttp.Interceptor;
import java.util.List;

/**
 * The interface for AutoRestAzureSpecialParametersTestClient class.
 */
public interface AutoRestAzureSpecialParametersTestClient {
    /**
     * Gets the URI used as the base for all cloud service requests.
     * @return The BaseUri value.
     */
    String getBaseUri();

    /**
     * Gets the list of interceptors the OkHttp client will execute.
     * @return the list of interceptors.
     */
    List<Interceptor> getClientInterceptors();

    /**
     * Gets the {@link AzureClient} used for long running operations.
     * @return the azure client;
     */
    AzureClient getAzureClient();

    /**
     * Gets The management credentials for Azure..
     *
     * @return the credentials value.
     */
    ServiceClientCredentials getCredentials();

    /**
     * Gets The subscription id, which appears in the path, always modeled in credentials. The value is always '1234-5678-9012-3456'.
     *
     * @return the subscriptionId value.
     */
    String getSubscriptionId();

    /**
     * Sets The subscription id, which appears in the path, always modeled in credentials. The value is always '1234-5678-9012-3456'.
     *
     * @param subscriptionId the subscriptionId value.
     */
    void setSubscriptionId(String subscriptionId);

    /**
     * Gets The api version, which appears in the query, the value is always '2015-07-01-preview'.
     *
     * @return the apiVersion value.
     */
    String getApiVersion();

    /**
     * Gets Gets or sets the preferred language for the response..
     *
     * @return the acceptLanguage value.
     */
    String getAcceptLanguage();

    /**
     * Sets Gets or sets the preferred language for the response..
     *
     * @param acceptLanguage the acceptLanguage value.
     */
    void setAcceptLanguage(String acceptLanguage);

    /**
     * Gets The retry timeout for Long Running Operations..
     *
     * @return the longRunningOperationRetryTimeout value.
     */
    int getLongRunningOperationRetryTimeout();

    /**
     * Sets The retry timeout for Long Running Operations..
     *
     * @param longRunningOperationRetryTimeout the longRunningOperationRetryTimeout value.
     */
    void setLongRunningOperationRetryTimeout(int longRunningOperationRetryTimeout);

    /**
     * Gets the XMsClientRequestIdOperations object to access its operations.
     * @return the xMsClientRequestId value.
     */
    XMsClientRequestIdOperations getXMsClientRequestId();

    /**
     * Gets the SubscriptionInCredentialsOperations object to access its operations.
     * @return the subscriptionInCredentials value.
     */
    SubscriptionInCredentialsOperations getSubscriptionInCredentials();

    /**
     * Gets the SubscriptionInMethodOperations object to access its operations.
     * @return the subscriptionInMethod value.
     */
    SubscriptionInMethodOperations getSubscriptionInMethod();

    /**
     * Gets the ApiVersionDefaultOperations object to access its operations.
     * @return the apiVersionDefault value.
     */
    ApiVersionDefaultOperations getApiVersionDefault();

    /**
     * Gets the ApiVersionLocalOperations object to access its operations.
     * @return the apiVersionLocal value.
     */
    ApiVersionLocalOperations getApiVersionLocal();

    /**
     * Gets the SkipUrlEncodingOperations object to access its operations.
     * @return the skipUrlEncoding value.
     */
    SkipUrlEncodingOperations getSkipUrlEncoding();

    /**
     * Gets the HeaderOperationsOperations object to access its operations.
     * @return the headerOperations value.
     */
    HeaderOperationsOperations getHeaderOperations();

}
